const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Frames_imagemDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const frames_imagem = await db.frames_imagem.create(
      {
        id: data.id || undefined,

        origem: data.origem || null,
        imagem_url: data.imagem_url || null,
        timestamp_frame: data.timestamp_frame || null,
        observacoes: data.observacoes || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await frames_imagem.setInspecao(data.inspecao || null, {
      transaction,
    });

    await frames_imagem.setClientes(data.clientes || null, {
      transaction,
    });

    return frames_imagem;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const frames_imagemData = data.map((item, index) => ({
      id: item.id || undefined,

      origem: item.origem || null,
      imagem_url: item.imagem_url || null,
      timestamp_frame: item.timestamp_frame || null,
      observacoes: item.observacoes || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const frames_imagem = await db.frames_imagem.bulkCreate(frames_imagemData, {
      transaction,
    });

    // For each item created, replace relation files

    return frames_imagem;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const frames_imagem = await db.frames_imagem.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.origem !== undefined) updatePayload.origem = data.origem;

    if (data.imagem_url !== undefined)
      updatePayload.imagem_url = data.imagem_url;

    if (data.timestamp_frame !== undefined)
      updatePayload.timestamp_frame = data.timestamp_frame;

    if (data.observacoes !== undefined)
      updatePayload.observacoes = data.observacoes;

    updatePayload.updatedById = currentUser.id;

    await frames_imagem.update(updatePayload, { transaction });

    if (data.inspecao !== undefined) {
      await frames_imagem.setInspecao(
        data.inspecao,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await frames_imagem.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return frames_imagem;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const frames_imagem = await db.frames_imagem.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of frames_imagem) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of frames_imagem) {
        await record.destroy({ transaction });
      }
    });

    return frames_imagem;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const frames_imagem = await db.frames_imagem.findByPk(id, options);

    await frames_imagem.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await frames_imagem.destroy({
      transaction,
    });

    return frames_imagem;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const frames_imagem = await db.frames_imagem.findOne(
      { where },
      { transaction },
    );

    if (!frames_imagem) {
      return frames_imagem;
    }

    const output = frames_imagem.get({ plain: true });

    output.pessoas_frame_frame = await frames_imagem.getPessoas_frame_frame({
      transaction,
    });

    output.inspecao = await frames_imagem.getInspecao({
      transaction,
    });

    output.clientes = await frames_imagem.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.inspecao_aerea,
        as: 'inspecao',

        where: filter.inspecao
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.inspecao
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  tipo_inspecao: {
                    [Op.or]: filter.inspecao
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.imagem_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'frames_imagem',
            'imagem_url',
            filter.imagem_url,
          ),
        };
      }

      if (filter.observacoes) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'frames_imagem',
            'observacoes',
            filter.observacoes,
          ),
        };
      }

      if (filter.timestamp_frameRange) {
        const [start, end] = filter.timestamp_frameRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp_frame: {
              ...where.timestamp_frame,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp_frame: {
              ...where.timestamp_frame,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.origem) {
        where = {
          ...where,
          origem: filter.origem,
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.frames_imagem.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('frames_imagem', 'imagem_url', query),
        ],
      };
    }

    const records = await db.frames_imagem.findAll({
      attributes: ['id', 'imagem_url'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['imagem_url', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.imagem_url,
    }));
  }
};
